/* Run all combinations for the PLLs to find suitable numbers for 10Hz steps.
 * 
 */
#define Version "PLL_calc_20201109_B"



unsigned long n = 1;
unsigned long r = 1;
unsigned long a = 1;
float p = 64;
float chan= 1;
float Ntot=1;
float fin= 6600000;
float frequency     =   3630000;      // frequency temp calcs
float ChSp = 10;
int Step = 0;

void CalcFreq()   
{ 
  Ntot=((p+1)*a)+(p*(n-a));
  ChSp =(fin / r);
  frequency=(Ntot * (fin / r));
//  frequency=(Ntot * ChSp);

if ((frequency > 43350000)&(frequency < 43352000))
            {
                  Serial.print(" r=");
                  Serial.print(r);
                  Serial.print(" n=");
                  Serial.print(n); 
                  Serial.print(" a=");
                  Serial.print(a);               
                  Serial.print ("  Frq=");    
                  Serial.print(frequency); 
                  Serial.print ("     ");
                  Step = int (frequency-43350000);
                  switch (Step) {
                   case 0:
                   Serial.print ("        ");
                   break; 
                   case 100:
                   Serial.print ("        ");
                   break; 
                   case 200:
                   Serial.print ("        ");
                   break; 
                   case 300:
                   Serial.print ("        ");
                   break; 
                   case 400:
                   Serial.print ("        ");
                   break; 
                   case 500:
                   Serial.print ("        ");
                   break; 
                   case 600:
                   Serial.print ("        ");
                   break; 
                   case 700:
                   Serial.print ("        ");
                   break; 
                   case 800:
                   Serial.print ("        ");
                   break; 
                   case 900:
                   Serial.print ("        ");
                   break; 
                   case 1000:
                   Serial.print ("        ");
                   break; 
                   case 1100:
                   Serial.print ("        ");
                   break; 
                   case 1200:
                   Serial.print ("        ");
                   break; 
                   case 1300:
                   Serial.print ("        ");
                   break; 
                   case 1400:
                   Serial.print ("        ");
                   break; 
                   case 1500:
                   Serial.print ("        ");
                   break; 
                   case 1600:
                   Serial.print ("        ");
                   break; 
                   case 1700:
                   Serial.print ("        ");
                   break; 
                   case 1800:
                   Serial.print ("        ");
                   break; 
                   case 1900:
                   Serial.print ("        ");
                   break; 
                  }
                  Serial.println(Step); 
             }         
}


void setup() {
  Serial.begin(115200);
  Serial.println(Version);

// test run with numbers read from Codan 8525A second PLL

  n = 437;
  r = 4264;
  a = 40;
  CalcFreq();
//  4264  437 40  << Codan numbers
 
  n = 497;
  r = 4848;
  a = 36;
  CalcFreq(); 
// 4848 497 36

  n = 572;
  r = 5578;
  a = 31;
  CalcFreq(); 
// 5578 572 31
 
  n = 423;
  r = 4125;
  a = 23;
  CalcFreq(); 
// 4125 423 23
  
  n = 413;
  r = 4030;
  a = 39;
  CalcFreq();
//  4030  413 39
 
  n = 533;
  r = 5198;
  a = 31;
  CalcFreq(); 
//   5198 533 31

  n = 568;
  r = 5541;
  a = 44;
  CalcFreq(); 
// 5541 568 44

  n = 603;
  r = 5884;
  a = 57;
  CalcFreq(); 
// 5884 603 57
 

Serial.println("Start calcs ");
Serial.println();
}



void loop() 
{


    for (r = 1; r <= 16384; r++)
    { 
      for (a = 1; a <= 128; a++) 
      {   
          for (n = 1; n <= 1024; n++) 
          { CalcFreq();        
          }
      }     
    }

      
Serial.print("Done!");
        while (n != n)
        {}
    }



